#ifndef PMESHLITEUTIL_HEADERS_H
#define PMESHLITEUTIL_HEADERS_H

#include <utils/Pm_MeshLite.H>

WINbool MakeEllipsoidNRing(PMeshLite &new_mesh,
                           const double r, const double a, const double b,
                           const int n, const double phi,
                           const double dr_edge, const double dr_cent,
                           const double dphi_edge, const double dphi_cent,
                           const double dtheta, const int nRings = 2 );

WINbool MakeSaddleNRing(PMeshLite &new_mesh,
                        const double r, const double a, const double b,
                        const int n, const double phi,
                        const double dr_edge, const double dr_cent,
                        const double dphi_edge, const double dphi_cent,
                        const double dtheta, const int nRings = 2 );

WINbool MakeSphericalNRing(PMeshLite &new_mesh,
                           const double r,
                           const int n, const double phi,
                           const double dr_edge, const double dr_cent,
                           const double dphi_edge, const double dphi_cent,
                           const double dtheta, const int nRings = 2 );

#endif