// Strictly for this:
#include "StdAfx.H"
#include <utils/Utils_Bits.H>
#include <utils/Utils_Io.H>

unsigned int UTILSBits::m_saiFlags[] = 
{
    1, 2, 4, 8, 16, 32, 64, 128,
    256, 512, 1024, 2048, 4096, 8192, 16384, 32768,
    65536, 131072, 262144, 524288, 1048576, 2097152, 4194304, 8388608,
    16777216, 33554432, 67108864, 134217728,
    268435456, 536870912, 1073741824, 2147483648
};

unsigned int UTILSBits::m_siFlagsAll = (unsigned int) 4294967295;

void UTILSBits::Write(ofstream &out) const 
{
    out << m_iNBits << " " << m_aiData.num( ) << " ";
    for (int i = 0; i < m_aiData.num( ); i++)
      out << m_aiData[i] << " ";
    out << "\n";
}

void UTILSBits::Read(ifstream &in) 
{
    int n;
    in >> m_iNBits >> n;
    m_aiData.need( n );

    for (int i = 0; i < m_aiData.num( ); i++)
      in >> m_aiData[i];

    ASSERT( in.good() );
}

void UTILSBits::WriteBinary( ofstream &out ) const 
{
    out << "Bits\n";
    UTILSIo::WriteBinary( m_iNBits, out );
    UTILSIo::WriteBinary( m_aiData, out );
}

void UTILSBits::ReadBinary( ifstream &in ) 
{
    char str[255];
    in >> str;
    in.ignore(2, '\n');
    ASSERT( !strcmp( str, "Bits" ) );

    UTILSIo::ReadBinary( m_iNBits, in );
    UTILSIo::ReadBinary( m_aiData, in );

    ASSERT( in.good() );
}

