#ifndef MCTEST_HEADERS_H
#define MCTEST_HEADERS_H

//#include <utils/Pm_Mesh.H>
#include <WINSystemDefines.H>
//#include <MC/MC_Fit.H>
#include <MC/MC_AllMetrics.H>
#include <utils/Pm_MeshLite.H>

extern void MCExtractRings(PMeshLite &in_mesh, const Vertex &v,
                           const int nRings, PMeshLite &out_mesh );
extern void MCdump(PMeshLite &mesh, const char *filename);
extern void MCdump(MCAllMetrics &data, const char *filename);
extern void MCdumpRanges(MCAllMetrics &data, const char *filename);

extern void MCtest(const int method = 0);
extern void MCtestReadMesh();
extern void MCtestAngles();
extern void MCtestArea();
extern void MCtestParam();
extern void MCtestParam2();
extern void MCtestPoly();
extern void MCtestPoly1();
extern void MCtestPoly2();
extern void MCtestPoly3();
extern void MCtestDCO();
extern void MCtestDCO2();
extern void MCtestANC();
extern void MCtestANC1();
extern void MCtestANC2();
extern void MCtestIEV();
extern void MCtestConic();
extern void MCtestConic1();
extern void MCtestRBF();
extern void MCtestAll();
extern void MCtestTorus();

#endif
