

extern "C" int dgesdd_(char *trans, 

                      long int *m, 

                      long int *n, 

                      double *a, 

                      long int *lda, 

                      double *s, 

                      double *u, 

                      long int *ldu, 

                      double *vt, 

                      long int *ldvt, 

                      double *work, 

                      long int *lwork, 

                      long int *iwork, 

                      long int *info );



    Array<double> adA( 2 * apt.num() ), adSigma(2), adU(4 * apt.num()), adVt(4), adWork( 3 * 2 * 2 + 2 * apt.num() );

    const double dDiv = 2.0 * M_PI / (double) apt.num();

    for ( FORINT i = 0; i < apt.num(); i++ ) {

        dots.Add( m_matRotFrame * in_aptContains[i]->Point3D(), UTILSColor::YELLOW );



        apt[i] = Alpha( *in_aptContains[i] );

        TRACE("%f %f\n", apt[i][0], apt[i][1] );

        //apt[i] = R2Pt( cos( i * dDiv ) * 1.3, sin( i* dDiv ) );

        adA[i] = apt[i][0] - 0.5; 

        adA[i + apt.num()] = apt[i][1] - 0.5; 

    }

    TRACE("\n");



    dots.Add( m_matRotFrame * ptCenter.Point3D(), UTILSColor::BLUE );

    dots.Add( R3Pt(0,0,1), UTILSColor::GREEN );

    dots.Add( R3Pt(1,0,1), UTILSColor::GREEN );

    UTILSDotArray::Write( dots, WINDataHome("test/projRot1.txt") );



    // SVD 

    long lM = apt.num();

    long lN = 2;

    char cTrans = 'S';

    long lWork = adWork.num(), iWork = 8 * 2, iInfo = 0;



    dgesdd_( &cTrans, &lM, &lN, &adA[0], &lM, &adSigma[0], &adU[0], &lM, &adVt[0], &lN, 

             &adWork[0], &lWork, &iWork, &iInfo );



    ASSERT( iInfo == 0 );

    const R2Vec vecX = UnitSafe( R2Vec( adVt[0], adVt[1] ) );

    const double dTheta1 = atan2( adVt[1], adVt[0] );

    const double dTheta2 = atan2( adVt[3], adVt[2] );

