/** \defgroup Fitting Data fitting

  Almost all of these libraries require a matrix solver class. Intel has
  their mkl solver http://www.intel.com/cd/software/products/asmo-na/eng/download/eval/219690.htm#perflib which is available for a free trial. I am currently using their matrix libraries. If, however, you can't get acces to them, there is source code available for building the Lapack, blas, f77 and i77 libraries in the ExternalLibraries directory. You will have to change the link paths.

Linking Intel's mkl: mkl_solver.lib libguide.lib mkl_c.lib These can be found in graphics/ExternalLibraries/lib/Intel. 

If you can't get access to those libraries, you can use Lapack, Blas, F77 and I77 (source in ExternalLibraries), but these do not support sparse matrices.

*/


//@{

/** \defgroup FittingElems Surface, curve, ellipse, line fitting.
   Libraries needed: Splines, Utils, Geometry
 */
/** \defgroup FittingMatrix Least squares, svd, constrained least squares */
/** \defgroup FittingSolver Simplex solver */
//@}

